import { AfterViewInit, DoCheck, ElementRef, EventEmitter, KeyValueDiffers, NgZone, OnDestroy } from '@angular/core';
import { ControlValueAccessor, NgControl } from '@angular/forms';
import { MatFormFieldControl } from '@angular/material/form-field';
import { Editor, EditorChangeLinkedList, EditorFromTextArea, ScrollInfo } from 'codemirror';
import { Subject } from 'rxjs';
export declare class MatCodemirrorComponent implements AfterViewInit, OnDestroy, ControlValueAccessor, MatFormFieldControl<string>, DoCheck {
    ngControl: NgControl;
    private _differs;
    private _ngZone;
    private static materialId;
    stateChanges: Subject<void>;
    id: string;
    describedBy: string;
    private onChange;
    private onTouched;
    private _required;
    private _focused;
    private _disabled;
    private _placeholder;
    private _value;
    private _differ;
    private _options;
    ngxMatCodemirror: boolean;
    className: string;
    name: string;
    autoFocus: boolean;
    preserveScrollPosition: boolean;
    cursorActivity: EventEmitter<Editor>;
    focusChange: EventEmitter<boolean>;
    scroll: EventEmitter<ScrollInfo>;
    ref: ElementRef;
    codeMirror: EditorFromTextArea;
    constructor(ngControl: NgControl, // mat
    _differs: KeyValueDiffers, _ngZone: NgZone);
    get shouldLabelFloat(): boolean;
    setDescribedByIds(ids: string[]): void;
    onContainerClick(event: MouseEvent): void;
    get required(): boolean;
    set required(req: boolean);
    get errorState(): boolean;
    get placeholder(): string;
    set placeholder(plh: string);
    get empty(): boolean;
    get value(): string;
    set value(value: string);
    get disabled(): boolean;
    set disabled(dis: boolean);
    get focused(): boolean;
    set focused(val: boolean);
    /**
     * set options for codemirror
     * @link http://codemirror.net/doc/manual.html#config
     */
    set options(value: {
        [key: string]: any;
    });
    ngAfterViewInit(): void;
    ngDoCheck(): void;
    ngOnDestroy(): void;
    codemirrorValueChanged(cm: Editor, change: EditorChangeLinkedList): void;
    setOptionIfChanged(optionName: string | any, newValue: any): void;
    focusChanged(focused: boolean): void;
    scrollChanged(cm: Editor): void;
    cursorActive(cm: Editor): void;
    writeValue(value: string): void;
    registerOnChange(fn: (value: string) => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    private normalizeLineEndings;
    private updateLineNumbers;
}
